// HPCSE I: MPI_Allreduce() 
#include <mpi.h>
#include <stdio.h>
#include <unistd.h>

int main(int argc, char** argv)
{
	MPI_Init(&argc, &argv);

	int rank, size;
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);

	double sum=0.;

	// do just one piece on each rank
	// something simple here
	double localsum=rank+1.0;

	MPI_Allreduce(&localsum, &sum, 1, MPI_DOUBLE, MPI_SUM, MPI_COMM_WORLD);

	printf("rank %d: sum= %lf\n", rank, sum);

	MPI_Finalize();

	return 0;
}
