// HPCSE I: Deadlock example 2: avoid the deadlock by reordering communication calls 
// (c) 2012 Matthias Troyer, ETH Zurich

#include <stdio.h>
#include <mpi.h>

int main(int argc, char** argv)
{
	MPI_Status status;
	int rank;
  
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  
	double ds=3.1415927; // to send
	double dr;           // to receive
	int tag=99;
  
	if (rank==0) {
		MPI_Ssend(&ds,1,MPI_DOUBLE,1,tag,MPI_COMM_WORLD);
		MPI_Recv (&dr,1,MPI_DOUBLE,1,tag,MPI_COMM_WORLD,&status);
	}
	else {
		MPI_Recv (&dr,1,MPI_DOUBLE,0,tag,MPI_COMM_WORLD,&status);
		MPI_Ssend(&ds,1,MPI_DOUBLE,0,tag,MPI_COMM_WORLD);
	}
  
	MPI_Finalize();
	return 0;
}
