// HPCSE I: MPI_Reduce()
#include <mpi.h>
#include <stdio.h>

int main(int argc, char** argv)
{
	MPI_Init(&argc, &argv);

	int rank, size;
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);

	double sum=0.;

	// do just one piece on each rank
	// something simple here
	double localsum=rank+1.0;

	MPI_Reduce(&localsum,&sum,1, MPI_DOUBLE, MPI_SUM, 0, MPI_COMM_WORLD);	// change 0 to 1

	if (rank == 0)	// comment this to see what the output will be on each rank
		printf("rank %d: sum= %lf\n", rank, sum);

	MPI_Finalize();

	return 0;
}
