// HPCSE I: MPI_Send()/MPI_Recv()
#include <mpi.h>
#include <stdio.h>
#include <unistd.h>

int main(int argc, char** argv)
{
	MPI_Init(&argc, &argv);

	int rank, size;
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);

	if (rank == 0)
	{
		double x=99;

		sleep(1);
		MPI_Send(&x, 1, MPI_DOUBLE, 1, 8888, MPI_COMM_WORLD);
	}
	else if (rank == 1)
	{
		double y=0;

		MPI_Status status;
		MPI_Recv(&y, 1, MPI_DOUBLE, 0, 8888, MPI_COMM_WORLD, &status);	// last argument can also be: MPI_STATUS_IGNORE 
		printf("rank %d: y = %lf\n", rank, y);
	}

	MPI_Finalize();
	return 0;
}
