// HPCSE I: MPI_Send()/MPI_Recv()
#include <mpi.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

int main(int argc, char** argv)
{
	MPI_Init(&argc, &argv);

	int rank, size;
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);

	if (rank == 0)
	{
		char text[256];
		strcpy(text, "Hello world!"); 

		sleep(1);
		MPI_Send(text, strlen(text), MPI_CHAR, 1, 8888, MPI_COMM_WORLD);
	}
	else if (rank == 1)
	{
		char text[256];

		MPI_Status status;
		MPI_Recv(text, 256, MPI_CHAR, 0, 8888, MPI_COMM_WORLD, &status);	// last argument can also be: MPI_STATUS_IGNORE 
		printf("rank %d: test = %s\n", rank, text);
	}

	MPI_Finalize();
	return 0;
}
