// HPCSE I: omp_allreduce() for reduction (+) among threads that do not share memory directly 
#include <omp.h>
#include <stdio.h>
#include <unistd.h>

void allreduce_double(double *local_sum, double *sum)
{
	static double reduce_buffer[1024]; // big enough 
	int rank = omp_get_thread_num();
	int size = omp_get_num_threads();

	reduce_buffer[rank] = *local_sum;

	#pragma omp barrier

	*sum = 0;
	//if (rank == 0)	// we do not want this
	{
		for (int i = 0; i < size; i++)
			*sum += reduce_buffer[i];
	}
}

int main(int argc, char** argv)
{
#pragma omp parallel
{
	int rank = omp_get_thread_num();

	double sum=0.;

	// do just one piece on each rank
	// something simple here
	double localsum=rank+1.0;

	allreduce_double(&localsum, &sum);

//	if (rank == 0)
	printf("rank %d: sum= %lf\n", rank, sum);

}

	return 0;
}
