// HPCSE I: omp_broadcast(): the master threads communicates a local value to the rest of the threads in the team (parallel region).
//	    The threads that do not share memory directly
#include <omp.h>
#include <stdio.h>
#include <unistd.h>

void broadcast_ulong(unsigned long *value)
{
	static unsigned long broadcast_buffer;
	int rank = omp_get_thread_num();

	if (rank == 0)
	{
		broadcast_buffer = *value; 
	}
	#pragma omp barrier
	if (rank != 0)
	{
		*value = broadcast_buffer;
	}
}

int main(int argc, char** argv)
{
#pragma omp parallel
{
	int rank = omp_get_thread_num();

	unsigned long nterms = 0;

	if (rank == 0) nterms = 100000000;

	broadcast_ulong(&nterms);

	printf("rank %d: nterms = %ld\n", rank, nterms);
}

	return 0;
}
