// HPCSE I: sendto()/recvfrom() routines for exchanging messages between threads that do not share memory directly
#include <omp.h>
#include <stdio.h>
#include <unistd.h>

static double buffer_data;
static int buffer_ready;
 
void sendto(double *x, int rank)
{
	#pragma omp critical
	{
		buffer_data = *x;
		buffer_ready = 1;
	}
}

void recvfrom(double *y, int rank)
{
	while (buffer_ready != 1) ;
	*y = buffer_data;
}


int main(int argc, char** argv)
{
#pragma omp parallel
{
	int rank = omp_get_thread_num();

	if (rank == 0)
	{
		double x=99; 

		sleep(1);
		sendto(&x, 1);
	}
	else if (rank == 1)
	{
		double y=0;

		recvfrom(&y, 0);
		printf("rank %d: y = %lf\n", rank, y);
	}
}

	return 0;
}
