// HPCSE I: sendto()/recvfrom() routines for exchanging messages between threads that do not share memory directly
// Note: this code is linked to the libsendrecv.a library
#include <omp.h>
#include <stdio.h>
#include <unistd.h>

#include "sendrecv.h"

void mymain(int argc, char** argv)	// consider this as your main() routine of your MPI code :-)
{
	int rank = omp_get_thread_num();

	if (rank == 0)
	{
		double x=99; 
		//sleep(1);	// uncomment this to ensure that rank 1 must wait for the message to 'arrive' 
		sendto(&x, 1);
	}
	else if (rank == 1)
	{
		double y=0;
		recvfrom(&y, 0);
		printf("rank %d: y = %lf\n", rank, y);
	}
}

int main(int argc, char** argv)
{
#pragma omp parallel
{
	mymain(argc, argv);
}

	return 0;
}
