// HPCSE I: pi computation, sequential code
#include <stdio.h>
#include <unistd.h>

int main(int argc, char** argv)
{
	int rank = 0;	// some parametrization, useful for the next steps 
	int size = 1;	// as above

	double sum=0.;
	double localsum=0.;
  
	unsigned long const nterms = 100000000;
	double const step = (nterms+0.5l) /  size;
  
	// do just one piece on each rank
	unsigned long start = rank * step;
	unsigned long end = (rank+1) * step;
	if (rank == size-1) end = nterms;
	for (unsigned long t = start; t < end; ++t)
		localsum += (1.0 - 2* (t % 2)) / (2*t + 1);
  
	sum = localsum;

	if (rank==0) // only one prints
		printf("rank %d: pi= %lf\n", rank, 4.*sum);
  
	return 0;
}
